#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <winsock.h>

static SOCKET sockfd;
static HANDLE hInput, hOutput;
static BOOL local_echo = TRUE;

void display(char *buffer, int length)
{
  static int esc = 0;
  while (length--) {
    char c = *buffer++;
    switch (c) {
      case 0:
        continue;
/*      case 27:
        esc = 1;
	continue;*/
    }
    if (c < 32 || c == 127) {
      DWORD written;
      WriteConsole(hOutput, &c, 1, &written, NULL);
      continue;
    }
    if (esc) {
      esc = 0;
    } else {
      DWORD written;
      WriteConsole(hOutput, &c, 1, &written, NULL);
    }
  }
}

DWORD receiver(LPDWORD lpdwParam)
{
  int length;
  unsigned char buffer[2048];
  int command_bytes = 0;
  unsigned char command_char = 0;
  while ((length = recv(sockfd, buffer, 2048, 0)) > 0) {
    unsigned char *buffer1 = buffer;
    while (length) {
      if (command_bytes) {
        if (command_bytes++ == 1) {
	  command_char = *buffer1;
	  if (command_char < 250) {
	    printf("\nFIXME: Unknown command %d.\n", command_char);
	    command_bytes = 0;
	  } else if (command_char == 0xff) {
	    display(buffer1, 1);
	    command_bytes = 0;
	  }
	} else {
	  unsigned char response[3];
	  response[0] = 0xff;
	  switch (command_char) {
	    case 0xfb:			// WILL
	      response[1] = 0xfe;	// DON'T
	      if (*buffer1 == 1) {
	        response[1] = 0xfd;	// DO ECHO
		local_echo = FALSE;
	      }
	      break;
	    case 0xfc:			// WON'T
	      response[1] = 0xfe;	// DON'T
	      break;
	    case 0xfd:			// DO
	      response[1] = 0xfc;	// WON'T
	      break;
	    case 0xfe:			// DON'T
	      response[1] = 0xfc;	// WON'T
	      break;
	  }
	  response[2] = *buffer1;
	  if (command_char != 0xfa) send(sockfd, response, 3, 0);
//	  printf("\nDEBUG: Command: %02X, Option: %02X, Response: %02X.\n",
//	    command_char, response[2], response[1]);
	  command_bytes = 0;
	}
	buffer1++;
	length--;
      } else {
        unsigned char *temp;
        if ((temp = memchr(buffer1, 0xff, length)) != NULL) {
          if (temp != buffer1) display(buffer1, temp - buffer1);
	  length -= temp - buffer1 + 1;
	  buffer1 = temp + 1;
	  command_bytes = 1;
        } else {
          display(buffer1, length);
	  length = 0;
        }
      }
    }
  }
  return 0;
}

void sender(void)
{
  int events;
  GetNumberOfConsoleInputEvents(hInput, &events);
  while (events > 0) {
    DWORD records;
    INPUT_RECORD inprec;
    ReadConsoleInput(hInput, &inprec, 1, &records);
    while (records > 0) {
      if ((inprec.EventType == KEY_EVENT) && inprec.Event.KeyEvent.bKeyDown) {
        if (!(inprec.Event.KeyEvent.dwControlKeyState & ENHANCED_KEY)) {
          char c;
          c = inprec.Event.KeyEvent.uChar.AsciiChar;
	  if (c != 0) {
            send(sockfd, &c, 1, 0);
  	    if (local_echo) {
	      putchar(c);
	    }
	    if (c == 0x0d) {
	      c = 0x0a;
	      send(sockfd, &c, 1, 0);
	      if (local_echo) {
	        putchar(c);
	      }
	    }
	  }
	} else {
//	  printf("Virt. code: %d\n", inprec.Event.KeyEvent.wVirtualKeyCode);
          char c;
	  c = inprec.Event.KeyEvent.wVirtualKeyCode;
	  switch (c) {
	    case 37:
	      send(sockfd, "\e[D", 3, 0);
	      break;
	    case 38:
	      send(sockfd, "\e[A", 3, 0);
	      break;
	    case 39:
	      send(sockfd, "\e[C", 3, 0);
	      break;
	    case 40:
	      send(sockfd, "\e[B", 3, 0);
	      break;
	  }
	}
      }
      records--;
    }
    events--;
  }
}

int main(int argc, char *argv[])
{
  int port = 23;
  WSADATA WSAData;
  struct sockaddr_in sin;
  HANDLE hThread, lphObjects[2];
  DWORD dwThreadId, dwEvent;
  if (argc != 2 && argc != 3) {
    puts("LTelnet v0.1.1 " __DATE__ " "  __TIME__ "\n");
    puts("Usage: ltelnet host [port]");
    return -1;
  }
  if (argc == 3) {
    sscanf(argv[2], "%d", &port);
  }
  if (WSAStartup(MAKEWORD(1, 1), &WSAData)) {
    puts("Error initializing Windows Sockets.");
    return -2;
  }
  if (WSAData.wVersion != MAKEWORD(1, 1)) {
    puts("Warning: Unsupported Winsock version.");
  }
  if ((sockfd = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET) {
    puts("Error creating socket.");
    WSACleanup();
    return -3;
  }
  memset(&sin, 0, sizeof(sin));
  sin.sin_family = AF_INET;
  sin.sin_port = htons(port);
  sin.sin_addr.s_addr = inet_addr(argv[1]);
  if (sin.sin_addr.s_addr == INADDR_NONE) {
    struct hostent *he;
    he = gethostbyname(argv[1]);
    if (he == NULL) {
      puts("Host unknown.");
      closesocket(sockfd);
      WSACleanup();
      return -4;
    }
    memcpy(&sin.sin_addr.s_addr, he->h_addr, he->h_length);
  }
  if (connect(sockfd, (struct sockaddr *)&sin, sizeof(sin))) {
    int error = WSAGetLastError();
    if (error == WSAENETDOWN) {
      puts("Network is down.");
    } else if (error == WSAECONNREFUSED) {
      puts("Connection refused.");
    } else if (error == WSAENETUNREACH) {
      puts("Network unreachable.");
    } else if (error == WSAETIMEDOUT) {
      puts("Connection timed out.");
    } else {
      puts("Error while connecting.");
    }
    closesocket(sockfd);
    WSACleanup();
    return -5;
  }
  hInput = GetStdHandle(STD_INPUT_HANDLE);
  hOutput = GetStdHandle(STD_OUTPUT_HANDLE);
  SetConsoleMode(hInput, 0);
  hThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)receiver, NULL, 0,
    &dwThreadId);
  if (hThread == NULL) {
    puts("Error creating thread.");
    closesocket(sockfd);
    WSACleanup();
    return -6;
  }
  lphObjects[0] = hThread;
  lphObjects[1] = hInput;
  do {
    dwEvent = WaitForMultipleObjects(2, lphObjects, FALSE, INFINITE);
    if (dwEvent == WAIT_OBJECT_0 + 1) sender();
  } while (dwEvent != WAIT_FAILED && dwEvent != WAIT_OBJECT_0);
  puts("Connection closed by foreign host.");
  closesocket(sockfd);
  WSACleanup();
  return 0;
}
